<template>

    <v-app-bar :clipped-left="$vuetify.breakpoint.lgAndUp" app color="blue darken-3" dark>
        <v-app-bar-nav-icon @click.stop="store.value.drawer = !store.value.drawer"/>
        <v-toolbar-title style="width: 300px" class="ml-0 pl-4">
            <span class="hidden-sm-and-down">Builderlytics</span>
        </v-toolbar-title>

        <v-text-field
                flat
                solo-inverted
                hide-details
                prepend-inner-icon="mdi-magnify"
                label="Search"
                class="hidden-sm-and-down"
        />
        <v-toolbar-title style="width: 300px" class="ml-7 pl-4">
            <v-select
                    flat
                    solo-inverted
                    hide-details
                    :items="tz"
                    v-model="store.value.tz"
                    prepend-inner-icon="$vuetify.icons.time
        "/>
        </v-toolbar-title>

        <v-spacer/>
        <v-menu offset-y :close-on-content-click="false">
            <template v-slot:activator="{ on, attrs }">
                <v-badge icon :content="notif" :value="notif" color="green" overlap :offset-x="20" :offset-y="20">
                    <v-btn icon v-bind="attrs" v-on="on">
                        <v-icon>mdi-bell</v-icon>
                    </v-btn>
                </v-badge>
            </template>
            <v-list>
                <v-list-item v-for="(a,i) in Alerts" :key="i">
                    <v-list-item two-line>
                        <v-list-item-icon>
                            <v-icon>
                                $vuetify.icons.warn
                            </v-icon>
                        </v-list-item-icon>
                        <v-list-item-content>
                            <v-list-item-title>{{a.error}}</v-list-item-title>
                            <v-list-item-subtitle>{{a.message}}</v-list-item-subtitle>
                        </v-list-item-content>
                        <v-list-item-content>
                            <v-list-item-subtitle>{{a.time}}</v-list-item-subtitle>
                        </v-list-item-content>
                        <v-list-item-action>
                            <v-btn icon>
                                <v-icon>
                                    $vuetify.icons.show
                                </v-icon>
                            </v-btn>
                        </v-list-item-action>

                        <v-list-item-action>
                            <v-btn icon @click="Dismiss(a.id)">
                                <v-icon>
                                    $vuetify.icons.del
                                </v-icon>
                            </v-btn>
                        </v-list-item-action>
                    </v-list-item>
                </v-list-item>
            </v-list>


        </v-menu>


        <v-progress-linear
                :active="store.value.loading"
                :indeterminate="store.value.loading"
                absolute
                bottom
                color="deep-purple accent-4"
        ></v-progress-linear>
    </v-app-bar>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
    import {Component, Prop, Vue} from 'vue-property-decorator';
    import {BStorage} from "../../../classLibrary/Storage";
    import moment from "moment-timezone";
    import {auth} from "../init";

    interface DisplayAlert {
        id: string;
        error: string;
        message: string;
        time: string;
    }

    @Component
    export default class ToolBar extends Vue {
        @Prop() store!: BStorage;

        tz: string[] = moment.tz.names();

        get notif(): number {
            return this.store.value.alerts.length;
        }

        get Alerts(): DisplayAlert[] {
            return this.store.value.alerts.Take(5).Map(x => {
                return {
                    id: x.id,
                    error: x.error, message: `${x.violator} at ${x.floorName} in ${x.zone}`,
                    time: moment(x.time).tz(this.store.value.tz).calendar()
                }
            })
        }

        async Dismiss(id: string) {
            if (auth.LoggedIn) {
                await this.store.Dismiss(id, auth.User, auth.Password);
            }
        }

    }
</script>
